/***************************************************************************
 *   Copyright (C) 2004 by Christoph Thielecke                             *
 *   crissi99@gmx.de                                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CONFIGLOGOPTIONS_H
#define CONFIGLOGOPTIONS_H

#include "configlogoptionsbase.h"
#include <qwidget.h>
#include <qcolor.h>

/**
@author Christoph Thielecke
*/
class ConfigLogOptions : public ConfigLogOptionsBase
{
	Q_OBJECT
public:
	ConfigLogOptions(QWidget *parent);

	~ConfigLogOptions();

public slots:
	void debugLogColorClicked();
	void infoLogColorClicked();
	void remoteLogColorClicked();
	void successLogColorClicked();
	void errorLogColorClicked();
	void useColorizedLogOutputToggled(bool);

protected:
	QColor InfoLogColor;
	QColor RemoteLogColor;
	QColor ErrorLogColor;
	QColor SuccessLogColor;
	QColor DebugLogColor;

};

#endif
